



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>题解-Codeforces710F String Set Queries</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">题解-Codeforces710F String Set Queries</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 18:04:10 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>咕了好久没更博客，最近得知可以去冬眠营玩耍，还可以搭顺风车回广州过年</p>
<p>（最近做到的比较有意思的题目：bzoj3958、hihocoder1419）</p>
<h2>Problem</h2>
<p><a href="http://codeforces.com/problemset/problem/710/F" rel="external nofollow noreferrer">Codeforces-710F</a>--<a href="https://www.luogu.org/problem/show?pid=CF710F" rel="external nofollow noreferrer">洛谷提交入口</a></p>
<p>题目概要：维护一个字符串集合，要求支持：加字符串、删字符串和查询当前所有已加入且未被删除的字符串在给出模板串中出现的次数（操作数&amp;字符串总长\(\leq 3\times 10^5\)）</p>
<h2>Solution</h2>
<p>挺有意思的一道题</p>
<p>看到多串匹配就猜测是AC自动机，然后动态加串删串不好处理</p>
<p>就将加入和删除维护两份，每份只需要维护加入即可，最后处理答案就在加入部分中匹配数减去删除部分中的匹配数（就像那个维护删除堆的套路）</p>
<p>（然后就可以分块了……一些短串就直接暴力重建AC自动机，而对于长串就处理出kmp数组直接kmp）</p>
<p>但是这个想法太惊悚了，不敢尝试</p>
<p>于是乎就有了二项堆的思想：维护二项堆核心思想就是二进制分组（第\(i\)个堆拥有\(2^i\)个元素，第\(i\)个堆可以由两个第\(i-1\)个堆合并而成）</p>
<p>类似的，这里可以将堆换为AC自动机：\(i\)号AC自动机维护\(2^i\)个串，若有两个\(i\)号AC自动机则合并成一个\(i+1\)号AC自动机，合并是拆除原AC自动机，然后暴力合并）</p>
<p>即使这样暴力，但每个串只会被合并\(log_2m\)次，而且每次查询只要在\(log_2m\)个AC自动机中查询即可，复杂度为AC自动机的复杂度再带个\(log_m\)</p>
<h2>Code</h2>
<p>注意内存回收，还有合并的时候可以直接trie树合并（但前提是不能将fail指针作为儿子以求速度）</p>
<pre class="prettyprint linenums"><code>#include &lt;bits/stdc++.h&gt;<br />
using namespace std;<br />
typedef long long ll;

inline void read(int&amp;x){<br />
	char c11=getchar();x=0;while(!isdigit(c11))c11=getchar();<br />
	while(isdigit(c11))x=x*10+c11-'0',c11=getchar();<br />
}

const int N=601000;<br />
struct node{<br />
	int ch[26],fail,end,sum;<br />
	inline void clear(){<br />
		for(int i=0;i&lt;26;++i)ch[i]=0;<br />
		fail=end=sum=0;<br />
	}<br />
}p[N];

struct RECYCLE{<br />
	int stk[N],top,tot;<br />
	RECYCLE(){top=tot=0;}<br />
	inline int newnode(){return top?stk[top--]:++tot;}<br />
	inline void del(int x){stk[++top]=x;p[x].clear();}<br />
}re;

struct AC_Auto{<br />
	int rt;<br />
	void clear(){p[rt=re.newnode()].fail=0;}<br />
	inline void ins(char*a){<br />
		int nw=rt;<br />
		for(int i=0,x;a[i];++i){<br />
			x=a[i]-'a';<br />
			if(!p[nw].ch[x])p[nw].ch[x]=re.newnode();<br />
			nw=p[nw].ch[x];<br />
		}++p[nw].end;<br />
	}<br />
	void build(){<br />
		static int q[N],he,ta;<br />
		q[he=ta=1]=rt;<br />
		while(he&lt;=ta){<br />
			int x=q[he++];<br />
			for(int i=0,c,t;i&lt;26;++i){<br />
				c=p[x].ch[i],t=p[x].fail;<br />
				if(!c)continue;<br />
				q[++ta]=c;<br />
				while(t &amp;&amp; !p[t].ch[i])t = p[t].fail;<br />
				if(t&amp;&amp;p[t].ch[i]!=c)p[c].fail = p[t].ch[i];<br />
				else p[c].fail=rt;<br />
				p[c].sum = p[c].end + p[p[c].fail].sum;<br />
			}<br />
		}<br />
	}

	ll scan(char*s){<br />
		int nw=rt;ll res=0;<br />
		for(int i=0,x;s[i];++i){<br />
			x=s[i]-'a';<br />
			while(nw!=rt&amp;&amp;!p[nw].ch[x])nw=p[nw].fail;<br />
			if(p[nw].ch[x])nw=p[nw].ch[x];<br />
			res+=p[nw].sum;<br />
		}return res;<br />
	}

	void merge(int&amp;x,int y){<br />
		if(!y)return ;<br />
		if(!x)x=re.newnode();<br />
		for(int i=0;i&lt;26;++i)<br />
			merge(p[x].ch[i],p[y].ch[i]);<br />
		p[x].end+=p[y].end;<br />
		re.del(y);<br />
	}<br />
};

struct NODE{<br />
	int tot,num[20];<br />
	AC_Auto ac[20];<br />
	NODE(){tot=0;memset(num,0,sizeof num);}<br />
	void INS(char*a){<br />
		num[++tot]=1;<br />
		ac[tot].clear();<br />
		ac[tot].ins(a);<br />
		while(tot&gt;1)<br />
			if(num[tot]==num[tot-1]){<br />
				ac[tot-1].merge(ac[tot-1].rt,ac[tot].rt);<br />
				num[tot-1]+=num[tot];<br />
				num[tot]=0,--tot;<br />
			}<br />
			else break;<br />
		ac[tot].build();<br />
	}<br />
	ll MAT(char*a){<br />
		ll res=0ll;<br />
		for(int i=1;i&lt;=tot;++i)<br />
			res+=ac[i].scan(a);<br />
		return res;<br />
	}<br />
}A,B;

char s[N];

int main(){<br />
	int m,op;read(m);<br />
	while(m--){<br />
		read(op);scanf(&quot;%s&quot;,s);<br />
		if(op==1)A.INS(s);<br />
		else if(op==2)B.INS(s);<br />
		else printf(&quot;%lld\n&quot;,A.MAT(s)-B.MAT(s)),fflush(stdout);<br />
	}return 0;<br />
}<br />
</code></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/m9600k39.html">RPC 的概念模型与实现解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o4p55q.html">Hibernate里save&lpar;&rpar;&comma;saveOrUpdate&lpar;&rpar;&comma;merge&lpar;&rpar;&comma;update&lpar;&rpar;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/1q2040o9.html">Spring MVC 3&period;0 深入及对注解的详细讲解</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvr2ro8.html">ASP&period;net页面代码执行顺序</a>
		</li>
						<li><a href="https://www.batexi.com/a/39r64dr9.html">dp px 转换工具</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyll0x8.html">ASP&period;NET MVC Area使用-将Area设置成独立项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/e9p50gz8.html">红字差评系列2&period;dwarf</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pjn7dk9.html">161013、java实现邮件群发带附件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxnk4mv8.html">让IE9支持html5</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xjywv8.html">ListViewDemo</a>
		</li>
						<li><a href="https://www.batexi.com/a/qde1olx9.html">Spring&sol;Hibernate Improved SQL Logging with log4jdbc---reference</a>
		</li>
						<li><a href="https://www.batexi.com/a/8k1g7rr9.html">YII数据库增删查改操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkk55j8.html">HDU 1885 Key Task  国家压缩&plus;搜索</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mm4dm8.html">Codeforces Round &num;270&lpar;利用prim算法&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4zporj9.html">EdgeRank</a>
		</li>
						<li><a href="https://www.batexi.com/a/93yj7zz8.html">Replication--进程无法在&OpenCurlyDoubleQuote;xxxx&rdquo;上执行&OpenCurlyDoubleQuote;sp&lowbar;replcmds&rdquo;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyjdxj9.html">An abandoned sentiment from past</a>
		</li>
						<li><a href="https://www.batexi.com/a/8ojoxd1q.html">（python功能定制）复杂的xml文件对比，产生HTML展示区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rgvzed8.html">django数据库迁移报错</a>
		</li>
						<li><a href="https://www.batexi.com/a/8megp5oq.html">【LOJ2586】【APIO2018】选圆圈 CDQ分治 扫描线 平衡树</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/qdwdkwv9.html">GET和POST传输方式</a>
			</li>
						<li><a href="https://www.batexi.com/a/qllnwgxq.html">IQueryable &amp;amp&semi; IEnumberable 区别</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jm6j5q.html">细说log4j之log4j 1&period;x</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwv5zgz8.html">三&period;HashMap原理及实现学习总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e452wj9.html">JDK8新特性04 方法引用与构造器引用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2zp0x9.html">nginx &plus; iis 使用介绍</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdojgv9.html">matplotlib-2D绘图库学习目录</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2zm2o9.html">写自适应的textarea文本域</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4jmv43q.html">mui的switch开关的应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gj47j79.html">jmeter 压力测试（二） 获取不同格式的当前时间</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
